/*

Copyright _ 2005, Dauger Research, Inc.  All rights reserved.

*/


function parseoutput(rawStr) {
	
	var items=rawStr.split(" "); 
	
	document.getElementById("nodecount").innerHTML = items[0];//.concat(" nodes found"); 
	
	document.getElementById("performancecapacity").innerHTML = parseInt(parseFloat(items[1]))+" MFlops"; 
	if (parseInt(parseFloat(items[2]))>0)
		document.getElementById("performanceinuse").innerHTML = "Using "+parseInt(parseFloat(items[2]))+" of"; 
	else if (parseInt(parseFloat(items[3]))>0)
		document.getElementById("performanceinuse").innerHTML = " ";//"Load: "+parseInt(parseFloat(items[3]))+" of"; 
	else
		document.getElementById("performanceinuse").innerHTML = " "; 
	
	{var context = document.getElementById('capacitybar').getContext('2d');
	var wd=document.getElementById('capacitybar').width;
	var ht=document.getElementById('capacitybar').height;
	
    context.clearRect(0, 0, wd, ht);
    context.setFillColor(0.2, 0.9, 0.2, 1.0);
    context.fillRect(0, 0, wd, ht);
    context.setFillColor(0.9, 0.9, 0.0, 1.0);
    if (parseFloat(items[1])>0)
    	context.fillRect(0, 1, parseInt((parseFloat(items[3])*wd)/parseFloat(items[1])), ht-2);
    context.setFillColor(1.0, 0.0, 0.0, 1.0);
    if (parseFloat(items[1])>0)
    	context.fillRect(0, 1, parseInt((parseFloat(items[2])*wd)/parseFloat(items[1])), ht-2);
   }
    
	return items[0].concat(" nodes found. ", items[1], " MFlops capacity, ", 
		items[2], " MFlops in use ", items[3]); 
	
	}

// swap
//
// Swaps out the current fortune for a new one.  Uses the Obj-C/JavaScript widget
// plugin to get the new fortune.
function swap() {

    if (widget) {  

       var outputStr = widget.system("/usr/bin/osascript networkscanscript", null).outputString;

		parseoutput(outputStr);	
		 document.getElementById("quote").innerHTML = " ";
		 				// drop in the new data
	}
	 //	document.getElementById("quote").innerHTML = "message was here";	
}

// next
//
// Performs the transition from the current fortune to the next one.
function next()
{
	hideContent();						// fades out the current fortune
	setTimeout("swap();",500);			// swaps in the new fortune
	setTimeout("showContent();",550);	// fades in the new fortune

}

function poochclick()
{
	widget.openApplication("com.daugerresearch.Pooch");
    var obj = widget.system("/usr/bin/osascript openpoochscript", null);
}

function setup()
{
	{var context = document.getElementById('capacitybar').getContext('2d');
	var wd=document.getElementById('capacitybar').width;
	var ht=document.getElementById('capacitybar').height;
	
    context.clearRect(0, 0, wd, ht);
    }
	next(); 
}


/**************************/
// Animation code
// Handles the fades in and out
/**************************/

var animation = {duration:0, starttime:0, to:1.0, now:1.0, from:0.0, firstElement:null, timer:null};

function showContent()
{

		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('quote');				// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation

}


function hideContent()
{

		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('quote');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();

}


function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

if (window.widget) {
	widget.onshow = next;
}
